

Friend Class Form1
    Inherits System.Windows.Forms.Form

    Private m As Threading.Mutex = New Threading.Mutex(False, "ThereminoHelperMutex")
    Private Function AlreadyRunning() As Boolean
        If Not m.WaitOne(0, False) Then
            'MsgBox("ThereminoHelper is already running", MsgBoxStyle.Information)
            Return True
        End If
        Return False
    End Function


    Private Slot_CursorX As Int32
    Private Slot_CursorY As Int32
    Private Slot_BarCode As Int32

    Private Sub Form_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        '
        If AlreadyRunning() Then
            End
        End If
        '
        EventsAreEnabled = False
        '
        ToolTips_Init()
        '
        Label_Code.Text = ""
        MemoryMappedFile_Init()
        Load_INI()
        Set_Props()
        ' ---------------------------------------------------------------- INIT
        Show()
        Refresh()
        ' ---------------------------------------------------------------- INIT TIMER 60 Hz
        Timer_60Hz.Interval = 15
        Timer_60Hz.Enabled = True
        ' ---------------------------------------------------------------- INIT TIMER 1 SECOND
        Timer_1Hz.Interval = 1000
        Timer_1Hz.Enabled = True
        '
        Me.Text = AppTitleAndVersion()
        EventsAreEnabled = True
        '
        txt_BarCode.Focus()
    End Sub

    Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CloseProgram()
    End Sub

    Private Sub CloseProgram()
        Timer_60Hz.Stop()
        Timer_1Hz.Stop()
        Save_INI()
        If Slot_CursorX >= 0 Then
            WriteSlot(Slot_CursorX, NAN_Sleep)
        End If
        If Slot_CursorY >= 0 Then
            WriteSlot(Slot_CursorY, NAN_Sleep)
        End If
        If Slot_BarCode >= 0 Then
            WriteSlot(Slot_BarCode, NAN_Sleep)
        End If
        End
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub


    ' ==============================================================================================================
    '   TIMER 100 Hz
    ' ==============================================================================================================
    Private Sub Timer_60Hz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_60Hz.Tick
        If Not EventsAreEnabled Then Return
        If Slot_CursorX >= 0 Then
            WriteSlot(Slot_CursorX, (1000 * Cursor.Position.X) \ Screen.PrimaryScreen.Bounds.Width)
        End If
        If Slot_CursorY >= 0 Then
            WriteSlot(Slot_CursorY, 1000 - (1000 * Cursor.Position.Y) \ Screen.PrimaryScreen.Bounds.Height)
        End If
        ' ------------------------------------------------- barcode is: 8 / 13(ean13) / or up to 14 chars + CR + LF
        If Slot_BarCode >= 0 Then
            Dim s As String = txt_BarCode.Text
            If s.EndsWith(vbLf) Then
                If s.Length <= 17 Then
                    Dim s1 As String = ""
                    Dim s2 As String = ""
                    s1 = Strings.Left(s, 7)
                    WriteSlot(Slot_BarCode, CSng(Val(s1)))
                    If s.Length > 9 Then
                        s2 = Strings.Mid(s, 8)
                        WriteSlot(Slot_BarCode + 1, CSng(Val(s2)))
                    End If
                    'System.Threading.Thread.Sleep(200)
                    Label_Code.Text = s1 & " " & s2
                End If
                txt_BarCode.Text = ""
            End If
        End If
    End Sub


    ' ==============================================================================================================
    '   TIMER 1 Hz
    ' ==============================================================================================================
    Private Sub Timer_1Hz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_1Hz.Tick
        If Not EventsAreEnabled Then Return
        ' -------------------------------------------------------- MUST BE CALLED EVERY SECOND
        TestCpuUsage(Nothing, PictureBox1)
        '
        TestShutDown()
    End Sub

    Private Sub TestShutDown()
        If MidMousePressed() Then
            If MyButton_ShutDownEnable.Checked Then
                If GroupBox_ShutDown.BackColor = Color.Red Then
                    Beep()
                    ForceWindowsShutDownAndPowerOff()
                    CloseProgram()
                End If
            Else
                CloseAllThereminiPrograms()
            End If
            GroupBox_ShutDown.BackColor = Color.Red
        Else
            If GroupBox_ShutDown.BackColor = Color.Red Then
                GroupBox_ShutDown.BackColor = Color.LightGoldenrodYellow
            End If
        End If
    End Sub


    ' ==============================================================================================================
    '   SET PROPERTIES
    ' ==============================================================================================================
    Private Sub txt_SlotCursorX_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SlotCursorX.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub
    Private Sub txt_SlotCursorY_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SlotCursorY.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub
    Private Sub txt_SlotBarcode_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txt_SlotBarcode.TextChanged
        If Not EventsAreEnabled Then Exit Sub
        Set_Props()
    End Sub

    Private Sub Set_Props()
        Slot_CursorX = txt_SlotCursorX.NumericValueInteger
        Slot_CursorY = txt_SlotCursorY.NumericValueInteger
        Slot_BarCode = txt_SlotBarcode.NumericValueInteger
    End Sub

    ' ================================================================================================
    '   SAVE INI ON LOST-FOCUS
    ' ================================================================================================
    Private Sub Properties_LostFocus(ByVal sender As Object, _
                                     ByVal e As System.EventArgs) Handles txt_SlotCursorX.LostFocus, _
                                                                          txt_SlotCursorY.LostFocus, _
                                                                          txt_BarCode.LostFocus
        Save_INI()
    End Sub


    ' ==============================================================================================================
    '   Close all
    ' ==============================================================================================================
    Private Sub btn_CloseAll_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_CloseAll.ClickButtonArea
        CloseAllThereminiPrograms()
    End Sub
    Private Sub CloseAllThereminiPrograms()
        Dim p() As System.Diagnostics.Process
        p = System.Diagnostics.Process.GetProcesses()
        For i As Int32 = 0 To p.Length - 1
            If Not p(i).ProcessName.StartsWith("Theremino_", StringComparison.OrdinalIgnoreCase) Then Continue For
            If p(i).Id = System.Diagnostics.Process.GetCurrentProcess.Id Then Continue For
            '
            'Debug.Print(p(i).ProcessName)
            '
            p(i).CloseMainWindow()
            p(i).Close()
        Next
        '
        p = System.Diagnostics.Process.GetProcesses()
        For i As Int32 = 0 To p.Length - 1
            If Not p(i).ProcessName.StartsWith("Theremino_", StringComparison.OrdinalIgnoreCase) Then Continue For
            If p(i).Id = System.Diagnostics.Process.GetCurrentProcess.Id Then Continue For
            '
            'Debug.Print(p(i).ProcessName)
            '
            If Not p(i).WaitForExit(1000) Then
                Try
                    p(i).Kill()
                Catch ex As Exception
                End Try
            End If
        Next
        '
        CloseProgram()
    End Sub

    '    '====================================================================
    'Sub kill(str): s.run "tskill """ + str + """ /A", 0: End Sub
    'Dim s: Set s = WScript.CreateObject ("WScript.shell")
    '    '====================================================================

    'kill "Theremino_*"



    ' ==============================================================================================================
    '   ToolTips
    ' ==============================================================================================================
    Private ttp1 As ToolTip
    Private Sub ToolTips_Init()
        ttp1 = New ToolTip
        ttp1.ShowAlways = True
        ttp1.UseAnimation = True
        ttp1.UseFading = True
        ttp1.IsBalloon = True
        ttp1.AutoPopDelay = 32700
        ttp1.InitialDelay = 500
        ttp1.ReshowDelay = 500
        ' --------------------------------------------------------------- Add here Controls and ToolTip-Text
        ttp1.SetToolTip(txt_BarCode, _
                        "Input from Barcode Reader" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The blinking cursor must be here")

        ttp1.SetToolTip(txt_SlotBarcode, _
                        "Barcode Output Slot" & vbCr & _
                        "-------------------------------------" & vbCr & _
                        "The code can be up to 14 chars + CL + LF" & vbCr & _
                        "The code is divided in two parts:" & vbCr & _
                        "First 7 chars are sent to Output Slot ""n""" & vbCr & _
                        "If there are remaining chars then" & vbCr & _
                        "they are sent to the Output Slot ""n+1""")

        'ttp1.SetToolTip(txt_SlotOut, _
        '                "Output Slot  ( output )" & vbCr & _
        '                "-------------------------------------" & vbCr & _
        '                "The current audio position is written" & vbCr & _
        '                "to this slot as a float value from 0.0" & vbCr & _
        '                "to 1000.0 to control other devices.")

        'ttp1.SetToolTip(txt_SlotOutChange, _
        '                "Change Slot ( output )" & vbCr & _
        '                "-------------------------------------" & vbCr & _
        '                "The current file index is written" & vbCr & _
        '                "to this slot to control other devices.")
    End Sub

    ' --------------------- this corrects the XP bug that causes tooltip disappearing for ever 
    Private Sub controls_MouseEnter(ByVal sender As Object, _
                                   ByVal e As System.EventArgs) Handles txt_BarCode.MouseEnter, _
                                                                        txt_SlotBarcode.MouseEnter
        ttp1.Active = False
        ttp1.Active = True
    End Sub

End Class