﻿Module Module_FillBars

    ' =======================================================================================
    '  CPU USAGE   >>> MUST BE CALLED ONE TIME EVERY SECOND <<<
    ' =======================================================================================
    Private TotalCpuCounter As PerformanceCounter
    'Private ProcessCpuCounter As PerformanceCounter
    'Private MemoryCounter As PerformanceCounter
    Private WithEvents AsyncTimer1 As System.Timers.Timer
    Private Sub AsyncTimer1_Elapsed(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles AsyncTimer1.Elapsed
        AsyncTimer1.Stop()
        TotalCpuCounter = New PerformanceCounter("Processor", "% Processor Time", "_Total")
        'ProcessCpuCounter = New PerformanceCounter("Process", "% Processor Time", Process.GetCurrentProcess.ProcessName)
        'MemoryCounter = New PerformanceCounter("Memory", "Available MBytes")
    End Sub
    Friend Sub TestCpuUsage(ByVal ProcessCpuPbox As PictureBox, ByVal TotalCpuPbox As PictureBox)
        If AsyncTimer1 Is Nothing Then
            AsyncTimer1 = New System.Timers.Timer
            AsyncTimer1.Interval = 1
            AsyncTimer1.Start()
        End If
        If TotalCpuCounter IsNot Nothing Then
            'Dim pcount As Int32 = System.Environment.ProcessorCount
            'ProgressBar_Cpu(ProcessCpuPbox, ProcessCpuCounter.NextValue / pcount)
            ProgressBar_Cpu(TotalCpuPbox, TotalCpuCounter.NextValue)
        End If
    End Sub


    ' =======================================================================================
    '  CPU TIME MILLISEC   >>> MUST BE CALLED ABOUT 30 TIMES PER SECOND <<<
    ' =======================================================================================
    'Private cpuTime_Font As Font
    'Friend Sub ShowCpuTime(ByVal pbox As PictureBox, ByVal timeMicrosec As Double)

    '    If pbox.Image Is Nothing Then
    '        ' -------------------------------------------------------- using a image for best performance
    '        InitPictureboxImage(pbox)
    '        cpuTime_Font = New Font("Tahoma", pbox.ClientSize.Height - 2, FontStyle.Regular, GraphicsUnit.Pixel)
    '    End If

    '    Static tt As Double = 0
    '    Dim delta As Double
    '    'delta = (TimeMicrosec - tt) / (tt * 0.001 + 1)

    '    delta = (timeMicrosec - tt) * 0.005
    '    delta = Math.Sign(delta) * (Math.Abs(delta) ^ 2)
    '    If delta > 10000 Then delta = 10000
    '    If delta < -10000 Then delta = -10000
    '    tt += delta

    '    ' ----------------------------------------------------------- using "Graphics.FromImage" for best performance
    '    Dim g As Graphics = Graphics.FromImage(pbox.Image)
    '    g.Clear(Color.MintCream)
    '    g.DrawString((tt / 1000).ToString("0.0 mS"), cpuTime_Font, Brushes.Black, 2, 0)

    '    ' ----------------------------------------------------------- final refresh - no flickering
    '    pbox.Refresh()
    'End Sub


    ' =======================================================================================
    '   ProgressBar_Cpu
    ' =======================================================================================
    Private Sub ProgressBar_Cpu(ByVal pbox As PictureBox, ByVal PercentualCPU As Double)
        '
        If pbox.Image Is Nothing Then
            InitPictureboxImage(pbox)
        End If
        '
        If PercentualCPU < 0 Then PercentualCPU = 0
        If PercentualCPU > 100 Then PercentualCPU = 100
        '
        Dim r As Rectangle
        r.X = 0
        r.Y = 0
        r.Width = CInt(pbox.Width / 2) - 1   ' <--- (-1) to correct the vertical green line in the middle
        r.Height = pbox.Height
        Dim b1 As Drawing2D.LinearGradientBrush = New Drawing2D.LinearGradientBrush(r, _
                                                                            Color.FromArgb(100, 255, 0), _
                                                                            Color.FromArgb(255, 200, 0), _
                                                                            Drawing2D.LinearGradientMode.Horizontal)
        Dim b2 As Drawing2D.LinearGradientBrush = New Drawing2D.LinearGradientBrush(r, _
                                                                            Color.FromArgb(255, 200, 0), _
                                                                            Color.FromArgb(255, 0, 0), _
                                                                            Drawing2D.LinearGradientMode.Horizontal)
        '
        Dim v As Int32 = CInt((PercentualCPU * pbox.Width) / 100)
        Dim vmid As Int32 = CInt(pbox.Width / 2)
        '
        ' ----------------------------------------------------------- using "Graphics.FromImage" for best performance
        Dim g As Graphics = Graphics.FromImage(pbox.Image)

        If PercentualCPU <= 50 Then
            g.FillRectangle(b1, 0, 0, v, pbox.ClientSize.Height)
        Else
            g.FillRectangle(b1, 0, 0, vmid, pbox.ClientSize.Height)
            g.FillRectangle(b2, vmid, 0, v - vmid, pbox.ClientSize.Height)
        End If
        Dim b As Brush = New SolidBrush(pbox.BackColor)
        g.FillRectangle(b, v, 0, pbox.ClientSize.Width - v, pbox.ClientSize.Height)
        '
        Dim f As Font = New Font("Tahoma", pbox.ClientSize.Height - 2, FontStyle.Regular, GraphicsUnit.Pixel)
        g.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAliasGridFit
        g.DrawString(Str(Int(PercentualCPU)) & "%", f, Brushes.Black, CInt(pbox.Width / 2 - 17), -2)
        '
        ' ----------------------------------------------------------- final refresh - no flickering
        pbox.Refresh()
    End Sub

End Module
